import traceback
from core.libs import *

from six.moves.BaseHTTPServer import HTTPServer
from six.moves.socketserver import ThreadingMixIn


class Server(ThreadingMixIn, HTTPServer):
    daemon_threads = True
    timeout = 1

    def __init__(self, address, handler, client):
        HTTPServer.__init__(self, address, handler)
        self._client = client
        self.running = True
        self.request = None

    def stop(self):
        self.running = False

    def serve(self):
        while self.running:
            try:
                self.handle_request()
            except Exception:
                logger.error()

    def run(self):
        t = Thread(target=self.serve, name='HTTP Server')
        t.daemon = self.daemon_threads
        t.start()

    def handle_error(self, request, client_address):
        if "socket.py" not in traceback.format_exc():
            logger.error()
